# Pajarito.jl

Pajarito is a **mixed-integer convex programming** (MICP) solver package written
in [Julia](http://julialang.org/).

MICP problems are convex except for restrictions that some variables take binary
or integer values.

Pajarito solves MICP problems in conic form, by constructing sequential
polyhedral outer approximations of the conic feasible set.

The underlying algorithm has theoretical finite-time convergence under
reasonable assumptions.

Pajarito accesses state-of-the-art MILP solvers and continuous conic solvers
through [MathOptInterface](https://github.com/jump-dev/MathOptInterface.jl).

## Pavito

For algorithms that use a derivative-based nonlinear programming (NLP) solver
(for example, Ipopt) instead of a conic solver, use [Pavito](https://github.com/jump-dev/Pavito.jl).

Pavito is a convex mixed-integer nonlinear programming (convex MINLP) solver.
Because Pavito relies on gradient cuts, it can fail near points of
non-differentiability. Pajarito may be more robust than Pavito on non-smooth
problems.

## License

`Pajarito.jl` is licensed under the [MPL 2.0 license](https://github.com/jump-dev/Pajarito.jl/blob/master/LICENSE.md).

## Installation

Install Pajarito using `Pkg.add`:
```julia
import Pkg
Pkg.add("Pajarito")
```

## MIP and continuous solvers

The algorithm implemented by Pajarito itself is relatively simple, and most of
the hard work is performed by the MIP outer approximation (OA) solver and the
continuous conic solver.

Therefore, in addition to installing Pajarito, you must also install a
mixed-integer linear programming solver and a continuous conic solver.

**The performance of Pajarito depends on these two types of solvers.**

The OA solver (typically a mixed-integer linear solver) is specified by the
`oa_solver` option. You must first load the Julia package that provides this
solver, for example, `using Gurobi`. The continuous conic solver is specified by
the `conic_solver` option.

See JuMP's [list of supported solvers](https://jump.dev/JuMP.jl/stable/installation/#Supported-solvers).

## Use with JuMP

To use Pajarito with JuMP, use:
```julia
using JuMP, Pajarito, HiGHS, Hypatia
model = Model(
    optimizer_with_attributes(
        Pajarito.Optimizer,
        "oa_solver" => optimizer_with_attributes(
            HiGHS.Optimizer,
            MOI.Silent() => true,
            "mip_feasibility_tolerance" => 1e-8,
            "mip_rel_gap" => 1e-6,
        ),
        "conic_solver" =>
            optimizer_with_attributes(Hypatia.Optimizer, MOI.Silent() => true),
    )
)
set_attribute(model, "time_limit", 60)
```

## Options

We list Pajarito's options below.

- `verbose::Bool` toggles printing
- `tol_feas::Float64` is the feasibility tolerance for conic constraints
- `tol_rel_gap::Float64` is the relative optimality gap tolerance
- `tol_abs_gap::Float64` is the absolute optimality gap tolerance
- `time_limit::Float64` sets the time limit (in seconds)
- `iteration_limit::Int` sets the iteration limit (for the iterative method)
- `use_iterative_method::Union{Nothing,Bool}` toggles the iterative algorithm;
  if `nothing` is specified, Pajarito defaults to the OA-solver-driven (single
  tree) algorithm if lazy callbacks are supported by the OA solver
- `use_extended_form::Bool` toggles the use of extended formulations for the
  second-order cone
- `solve_relaxation::Bool` toggles solution of the continuous conic relaxation
- `solve_subproblems::Bool` toggles solution of the continuous conic subproblems
- `use_init_fixed_oa::Bool` toggles initial fixed OA cuts
- `oa_solver::Union{Nothing,MOI.OptimizerWithAttributes}` is the OA solver
- `conic_solver::Union{Nothing,MOI.OptimizerWithAttributes}` is the conic solver

**Pajarito may require tuning of parameters to improve convergence.**

For example, it often helps to tighten the OA solver's integrality tolerance.
OA solver and conic solver options must be specified directly to those solvers.

Note: if `solve_subproblems` is true, Pajarito usually returns a solution
constructed from one of the conic solver's feasible solutions; since the conic
solver is not subject to the same feasibility tolerances as the OA solver,
Pajarito's solution will not necessarily satisfy `tol_feas`.

## Cone interface

Pajarito has a generic cone interface (see the [cones folder](src/Cones/)) that
allows the user to add support for new convex cones.

To illustrate, in the experimental package [PajaritoExtras](https://github.com/chriscoey/PajaritoExtras.jl)
we have extended Pajarito by adding support for several cones recognized by
[Hypatia.jl](https://github.com/chriscoey/Hypatia.jl) (a continuous conic solver
with its own generic cone interface).

The examples folder of PajaritoExtras also contains many applied mixed-integer
convex problems that are solved using Pajarito.

## Bug reports and support

Please report any issues via the GitHub
[issue tracker](https://github.com/jump-dev/Pajarito.jl/issues).

All types of issues are welcome and encouraged; this includes bug reports,
documentation typos, and feature requests. The [Optimization (Mathematical)](https://discourse.julialang.org/c/domain/opt)
category on Discourse is appropriate for general discussion.

## References

If you find Pajarito useful in your work, we kindly request that you cite the
following paper ([arXiv preprint](http://arxiv.org/abs/1808.05290)), which is
recommended reading for advanced users:

```
@article{CoeyLubinVielma2020,
    title={Outer approximation with conic certificates for mixed-integer convex problems},
    author={Coey, Chris and Lubin, Miles and Vielma, Juan Pablo},
    journal={Mathematical Programming Computation},
    volume={12},
    number={2},
    pages={249--293},
    year={2020},
    publisher={Springer}
}
```

Note this paper describes a legacy MathProgBase version of Pajarito, which is
available on the [`mathprogbase` branch](https://github.com/jump-dev/Pajarito.jl/tree/mathprogbase)
of this repository. Starting with version v0.8.0, Pajarito supports
MathOptInterface instead of MathProgBase.

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# optimizer struct

mutable struct Optimizer <: MOI.AbstractOptimizer
    # options
    verbose::Bool
    tol_feas::Float64
    tol_rel_gap::Float64
    tol_abs_gap::Float64
    time_limit::Float64
    iteration_limit::Int
    use_iterative_method::Union{Nothing,Bool}
    use_extended_form::Bool
    solve_relaxation::Bool
    solve_subproblems::Bool
    use_init_fixed_oa::Bool
    oa_solver::Union{Nothing,MOI.OptimizerWithAttributes}
    conic_solver::Union{Nothing,MOI.OptimizerWithAttributes}

    # optimizers
    oa_opt::Union{Nothing,MOI.AbstractOptimizer}
    conic_opt::Union{Nothing,MOI.AbstractOptimizer}

    # problem data
    obj_sense::MOI.OptimizationSense
    obj_offset::Float64
    c::Vector{Float64}
    A::SparseArrays.SparseMatrixCSC{Float64,Int}
    b::Vector{Float64}
    G::SparseArrays.SparseMatrixCSC{Float64,Int}
    h::Vector{Float64}
    cones::Vector{MOI.AbstractVectorSet}
    cone_idxs::Vector{UnitRange{Int}}
    num_int_vars::Int
    SOS12_cons::Vector{
        Pair{Vector{Int},<:Union{MOI.SOS1{Float64},MOI.SOS2{Float64}}},
    }

    # models, variables, etc
    oa_model::JuMP.Model
    relax_model::JuMP.Model
    subp_model::JuMP.Model
    oa_x::Vector{JuMP.VariableRef}
    relax_x::Vector{JuMP.VariableRef}
    subp_x::Vector{JuMP.VariableRef}
    subp_eq::JuMP.ConstraintRef
    subp_cones::Vector{JuMP.ConstraintRef}
    subp_cone_idxs::Vector{UnitRange{Int}}
    c_int::Vector{Float64}
    A_int::SparseArrays.SparseMatrixCSC{Float64,Int}
    G_int::SparseArrays.SparseMatrixCSC{Float64,Int}
    b_cont::Vector{Float64}
    oa_vars::Vector{JuMP.VariableRef}
    relax_oa_cones::Vector{JuMP.ConstraintRef}
    subp_oa_cones::Vector{JuMP.ConstraintRef}
    cone_caches::Vector{Cache}
    oa_cone_idxs::Vector{UnitRange{Int}}
    oa_slack_idxs::Vector{Vector{Int}}

    # used/modified during optimize
    lazy_cb::Any
    new_incumbent::Bool
    int_sols_cuts::Dict{UInt,Vector{JuMP.AffExpr}}
    use_oa_starts::Bool

    # used by MOI wrapper
    incumbent::Vector{Float64}
    warm_start::Vector{Float64}
    status::MOI.TerminationStatusCode
    solve_time::Float64
    obj_value::Float64
    obj_bound::Float64
    num_cuts::Int
    num_iters::Int
    num_lazy_cbs::Int
    num_heuristic_cbs::Int

    # useful for PajaritoExtras
    sep_solver::Union{Nothing,MOI.OptimizerWithAttributes}
    unique_cones::Dict{UInt,Any}

    function Optimizer(
        verbose::Bool = true,
        tol_feas::Float64 = 1e-7,
        tol_rel_gap::Float64 = 1e-5,
        tol_abs_gap::Float64 = 1e-4,
        time_limit::Float64 = 1e6,
        iteration_limit::Int = 1000,
        use_iterative_method::Union{Nothing,Bool} = nothing,
        use_extended_form::Bool = true,
        solve_relaxation::Bool = true,
        solve_subproblems::Bool = true,
        use_init_fixed_oa::Bool = true,
        oa_solver::Union{Nothing,MOI.OptimizerWithAttributes} = nothing,
        conic_solver::Union{Nothing,MOI.OptimizerWithAttributes} = nothing,
        sep_solver::Union{Nothing,MOI.OptimizerWithAttributes} = nothing,
    )
        opt = new()
        opt.verbose = verbose
        opt.tol_feas = tol_feas
        opt.tol_rel_gap = tol_rel_gap
        opt.tol_abs_gap = tol_abs_gap
        opt.time_limit = time_limit
        opt.iteration_limit = iteration_limit
        opt.use_iterative_method = use_iterative_method
        opt.use_extended_form = use_extended_form
        opt.solve_relaxation = solve_relaxation
        opt.solve_subproblems = solve_subproblems
        opt.use_init_fixed_oa = use_init_fixed_oa
        opt.oa_solver = oa_solver
        opt.conic_solver = conic_solver
        opt.oa_opt = nothing
        opt.conic_opt = nothing
        opt.sep_solver = sep_solver
        return empty_optimize(opt)
    end
end

function empty_optimize(opt::Optimizer)
    opt.status = MOI.OPTIMIZE_NOT_CALLED
    opt.solve_time = NaN
    opt.obj_value = NaN
    opt.obj_bound = NaN
    opt.num_cuts = 0
    opt.num_iters = 0
    opt.num_lazy_cbs = 0
    opt.num_heuristic_cbs = 0
    opt.lazy_cb = nothing
    opt.new_incumbent = false
    opt.int_sols_cuts = Dict{UInt,Vector{JuMP.AffExpr}}()

    if !isnothing(opt.oa_opt)
        MOI.empty!(opt.oa_opt)
    end
    if !isnothing(opt.conic_opt)
        MOI.empty!(opt.conic_opt)
    end
    return opt
end

# check/instantiate OA solver and set default for use_iterative_method
function get_oa_opt(opt::Optimizer)
    if isnothing(opt.oa_opt)
        if isnothing(opt.oa_solver)
            error("No outer approximation solver specified (set `oa_solver`)")
        end
        opt.oa_opt = MOI.instantiate(opt.oa_solver, with_bridge_type = Float64)

        # check whether lazy constraints are supported
        supports_lazy = MOI.supports(opt.oa_opt, MOI.LazyConstraintCallback())
        if isnothing(opt.use_iterative_method)
            # default to one tree method if possible
            opt.use_iterative_method = !supports_lazy
        elseif !opt.use_iterative_method && !supports_lazy
            error(
                "Outer approximation solver (`oa_solver`) does not support " *
                "lazy constraint callbacks (`use_iterative_method` must be `true`)",
            )
        end
    end
    return opt.oa_opt
end

# check/instantiate conic solver
function get_conic_opt(opt::Optimizer)
    if isnothing(opt.conic_opt)
        if isnothing(opt.conic_solver)
            error("No primal-dual conic solver specified (set `conic_solver`)")
        end
        opt.conic_opt =
            MOI.instantiate(opt.conic_solver, with_bridge_type = Float64)
    end
    return opt.conic_opt
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# conic and OA models for OA algorithms

# setup conic and OA models
function setup_models(opt::Optimizer)
    @assert !opt.solve_subproblems || isempty(opt.SOS12_cons)

    # mixed-integer OA model, add discrete constraints later
    oa_model = opt.oa_model = JuMP.Model(() -> opt.oa_opt)
    oa_x = opt.oa_x = JuMP.@variable(oa_model, [1:length(opt.c)])
    JuMP.@objective(oa_model, Min, LinearAlgebra.dot(opt.c, oa_x))
    JuMP.@constraint(oa_model, opt.A * oa_x .== opt.b)
    oa_aff = JuMP.@expression(oa_model, opt.h - opt.G * oa_x)

    if opt.solve_relaxation
        # continuous relaxation model
        relax_model = opt.relax_model = JuMP.Model(() -> opt.conic_opt)
        relax_x = opt.relax_x = JuMP.@variable(relax_model, [1:length(opt.c)])
        JuMP.@objective(relax_model, Min, LinearAlgebra.dot(opt.c, relax_x))
        JuMP.@constraint(
            relax_model,
            opt.b - opt.A * relax_x in MOI.Zeros(length(opt.b))
        )
        relax_aff = JuMP.@expression(relax_model, opt.h - opt.G * relax_x)
    end

    if opt.solve_subproblems
        # differentiate integer and continuous variables
        num_cont_vars = length(opt.c) - opt.num_int_vars
        int_range = 1:(opt.num_int_vars)
        cont_range = (opt.num_int_vars+1):length(opt.c)
        opt.c_int = opt.c[int_range]
        opt.G_int = opt.G[:, int_range]
        c_cont = opt.c[cont_range]
        G_cont = opt.G[:, cont_range]
        A_cont = opt.A[:, cont_range]

        # remove zero rows in A_cont for subproblem
        keep_rows = (vec(maximum(abs, A_cont, dims = 2)) .>= 1e-10)
        A_cont = A_cont[keep_rows, :]
        opt.b_cont = opt.b[keep_rows]
        opt.A_int = opt.A[keep_rows, int_range]

        # continuous subproblem model
        subp_model = opt.subp_model = JuMP.Model(() -> opt.conic_opt)
        subp_x = opt.subp_x = JuMP.@variable(subp_model, [1:num_cont_vars])
        JuMP.@objective(subp_model, Min, LinearAlgebra.dot(c_cont, subp_x))
        K0 = MOI.Zeros(length(opt.b_cont))
        opt.subp_eq = JuMP.@constraint(subp_model, -A_cont * subp_x in K0)
        subp_aff = JuMP.@expression(subp_model, -G_cont * subp_x)
    end

    oa_vars = opt.oa_vars = copy(oa_x)
    opt.subp_cones = JuMP.ConstraintRef[]
    opt.subp_cone_idxs = UnitRange{Int}[]
    opt.relax_oa_cones = JuMP.ConstraintRef[]
    opt.subp_oa_cones = JuMP.ConstraintRef[]
    opt.cone_caches = Cache[]
    opt.oa_cone_idxs = UnitRange{Int}[]
    opt.oa_slack_idxs = UnitRange{Int}[]
    opt.unique_cones = Dict{UInt,Any}()

    for (cone, idxs) in zip(opt.cones, opt.cone_idxs)
        oa_supports = MOI.supports_constraint(
            opt.oa_opt,
            MOI.VectorAffineFunction{Float64},
            typeof(cone),
        )

        if opt.solve_relaxation
            relax_cone_i =
                JuMP.@constraint(relax_model, relax_aff[idxs] in cone)
            if !oa_supports
                push!(opt.relax_oa_cones, relax_cone_i)
            end
        end

        if opt.solve_subproblems
            subp_aff_i = subp_aff[idxs]
            if !oa_supports || !iszero(subp_aff_i)
                # conic constraint must be added to subproblem
                subp_cone_i = JuMP.@constraint(subp_model, subp_aff_i in cone)
                push!(opt.subp_cones, subp_cone_i)
                push!(opt.subp_cone_idxs, idxs)
            end
            if !oa_supports
                push!(opt.subp_oa_cones, subp_cone_i)
            end
        end

        oa_aff_i = oa_aff[idxs]
        if oa_supports
            JuMP.@constraint(oa_model, oa_aff_i in cone)
        else
            # add slack variables where useful and modify oa_aff_i
            (slacks, slack_idxs) = create_slacks(oa_model, oa_aff_i)
            append!(oa_vars, slacks)
            push!(opt.oa_slack_idxs, idxs[slack_idxs])

            # set up cone cache and extended formulation
            cache = Cones.create_cache(oa_aff_i, cone, opt)
            ext_i = Cones.setup_auxiliary(cache, opt)
            append!(oa_vars, ext_i)
            push!(opt.cone_caches, cache)
            push!(opt.oa_cone_idxs, idxs)
        end
    end
    @assert JuMP.num_variables(oa_model) == length(oa_vars)

    opt.use_oa_starts = MOI.supports(
        JuMP.backend(oa_model),
        MOI.VariablePrimalStart(),
        MOI.VariableIndex,
    )
    if opt.use_oa_starts && !isempty(opt.warm_start)
        if any(isnan, opt.warm_start)
            @warn("warm start is only partial so will be ignored")
        else
            oa_start = get_oa_start(opt, opt.warm_start)
            JuMP.set_start_value.(oa_vars, oa_start)
        end
    end

    isempty(opt.cone_caches) || return false
    # no conic constraints need outer approximation, so just solve the OA model and finish
    if opt.verbose
        println("no conic constraints need outer approximation")
    end

    # add integrality constraints to OA model and solve
    add_discrete_constraints(opt)
    time_finish = check_set_time_limit(opt, oa_model)
    time_finish && return true
    JuMP.optimize!(oa_model)

    opt.status = JuMP.termination_status(oa_model)
    if opt.status == MOI.OPTIMAL
        opt.obj_value = JuMP.objective_value(oa_model)
        opt.obj_bound = get_objective_bound(oa_model)
        opt.incumbent = JuMP.value.(oa_x)
    end
    return true
end

# to balance variable dimension and sparsity of the constraint matrix with K* cuts, only add
# slacks if number of variables involved in this constraint exceeds the constraint dimension
function create_slacks(model::JuMP.Model, expr_vec::Vector{JuMP.AffExpr})
    slacks = JuMP.VariableRef[]
    slack_idxs = Int[]
    vars = Set(k.index.value for f in expr_vec for k in keys(f.terms))
    if length(vars) > length(expr_vec)
        # number of variables in expr_vec exceeds dimension of expr_vec
        for (j, expr_j) in enumerate(expr_vec)
            terms = JuMP.linear_terms(expr_j)
            length(terms) <= 1 && continue

            # affine expression has more than one variable, so add a slack variable
            s_j = JuMP.@variable(model)
            JuMP.@constraint(model, s_j .== expr_j)
            expr_vec[j] = s_j
            push!(slacks, s_j)
            push!(slack_idxs, j)
        end
    end
    return (slacks, slack_idxs)
end

function get_oa_start(opt::Optimizer, x_start::Vector{Float64})
    n = length(opt.incumbent)
    @assert length(x_start) == n
    oa_start = fill(NaN, length(opt.oa_vars))
    oa_start[1:n] .= x_start

    s_start = opt.h - opt.G * x_start
    for (i, cache) in enumerate(opt.cone_caches)
        slack_idxs = opt.oa_slack_idxs[i]
        if !isempty(slack_idxs)
            # set slack variables start
            slack_start = s_start[slack_idxs]
            dim = length(slack_start)
            oa_start[n.+(1:dim)] .= slack_start
            n += dim
        end

        ext_dim = Cones.num_ext_variables(cache)
        if !iszero(ext_dim)
            # set auxiliary variables start
            s_start_i = s_start[opt.oa_cone_idxs[i]]
            ext_start = Cones.extend_start(cache, s_start_i, opt)
            @assert ext_dim == length(ext_start)
            oa_start[n.+(1:ext_dim)] .= ext_start
            n += ext_dim
        end
    end
    @assert n == length(oa_start)

    @assert !any(isnan, oa_start)
    return oa_start
end

function modify_subproblem(int_sol::Vector{Int}, opt::Optimizer)
    # TODO maybe also modify the objective constant using dot(opt.c_int, int_sol), could be nonzero
    moi_model = JuMP.backend(opt.subp_model)

    new_b = opt.b_cont - opt.A_int * int_sol
    MOI.modify(
        moi_model,
        JuMP.index(opt.subp_eq),
        MOI.VectorConstantChange(new_b),
    )

    new_h = opt.h - opt.G_int * int_sol
    for (cr, idxs) in zip(opt.subp_cones, opt.subp_cone_idxs)
        MOI.modify(
            moi_model,
            JuMP.index(cr),
            MOI.VectorConstantChange(new_h[idxs]),
        )
    end
    return
end

function add_discrete_constraints(opt::Optimizer)
    JuMP.set_integer.(opt.oa_x[1:(opt.num_int_vars)])
    for (idxs, si) in opt.SOS12_cons
        JuMP.@constraint(opt.oa_model, opt.oa_x[idxs] in si)
    end
    return
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

import Test
import GLPK
import Hypatia
import MathOptInterface as MOI

glpk = MOI.OptimizerWithAttributes(
    GLPK.Optimizer,
    MOI.Silent() => true,
    "tol_int" => 1e-10,
    "tol_bnd" => 1e-10,
    "mip_gap" => 1e-10,
)

hypatia = MOI.OptimizerWithAttributes(
    Hypatia.Optimizer,
    MOI.Silent() => true,
    "near_factor" => 100,
    "tol_feas" => 1e-8,
    "tol_rel_opt" => 1e-8,
    "tol_abs_opt" => 1e-8,
    "tol_illposed" => 1e-8,
    "tol_slow" => 2e-2,
    "tol_inconsistent" => 1e-7,
)

println("starting Pajarito tests")
Test.@testset "Pajarito tests" begin
    println("starting MOI tests")
    include("MOI_tests.jl")
    Test.@testset "MOI tests" begin
        TestMOI.runtests(glpk, hypatia)
    end

    println("starting JuMP tests")
    include("JuMP_tests.jl")
    Test.@testset "JuMP tests" begin
        TestJuMP.runtests(glpk, hypatia)
    end

    println("starting CBF tests")
    include("CBF_tests.jl")
    Test.@testset "CBF tests" begin
        TestCBF.runtests(glpk, hypatia)
    end
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# outer approximation algorithms

function optimize(opt::Optimizer)
    start_optimize(opt)

    # setup models
    setup_finish = setup_models(opt)
    if setup_finish
        finish_optimize(opt)
        return
    end

    if opt.solve_relaxation
        # solve continuous relaxation
        relax_finish = solve_relaxation(opt)
        if relax_finish
            finish_optimize(opt)
            return
        end

        # add continuous relaxation cuts
        add_relax_cuts(opt)
    end

    # add variable bounds and (optionally) initial fixed cuts
    add_init_cuts(opt)

    # ensure continuous relaxation of OA model is bounded
    num_relax_iters = 0
    while num_relax_iters < 10
        finish_bound = run_oa_relax_bound(opt)
        finish_bound && break
        num_relax_iters += 1
    end
    if opt.verbose
        println("separated $num_relax_iters rays before imposing integrality")
    end

    # add discrete constraints to OA model
    add_discrete_constraints(opt)

    # run main OA algorithm
    if opt.use_iterative_method
        print_header(opt)
        while true
            opt.num_iters += 1
            finish_iter = run_iterative_method(opt)
            finish_iter && break
        end
    else
        run_one_tree_method(opt)
    end

    finish_optimize(opt)
    return
end

# one iteration of the iterative method
function run_iterative_method(opt::Optimizer)
    # solve OA model
    time_finish = check_set_time_limit(opt, opt.oa_model)
    time_finish && return true
    JuMP.optimize!(opt.oa_model)

    oa_status = JuMP.termination_status(opt.oa_model)
    if oa_status == MOI.INFEASIBLE
        if opt.verbose
            println("infeasibility detected while iterating; terminating")
        end
        opt.status = oa_status
        return true
    elseif oa_status == MOI.TIME_LIMIT
        if opt.verbose
            println("OA solver timed out")
        end
        opt.status = oa_status
        return true
    elseif oa_status != MOI.OPTIMAL
        @warn("OA solver status $oa_status is not handled")
        opt.status = MOI.OTHER_ERROR
        return true
    end

    # update objective bound
    obj_bound = get_objective_bound(opt.oa_model)
    if !isfinite(obj_bound) && oa_status == MOI.OPTIMAL
        obj_bound = JuMP.objective_value(opt.oa_model)
    end
    opt.obj_bound = obj_bound

    subp_cuts_added = false
    if opt.solve_subproblems
        # solve conic subproblem with fixed integer solution and update incumbent
        # check if integer solution is repeated
        int_sol = get_integral_solution(opt)
        hash_int_sol = hash(int_sol)
        if haskey(opt.int_sols_cuts, hash_int_sol)
            @warn("integral solution repeated")
        else
            # new integral solution: solve subproblem and add cuts
            opt.int_sols_cuts[hash_int_sol] = JuMP.AffExpr[]
            subp_failed = solve_subproblem(int_sol, opt)
            if !subp_failed
                subp_cuts_added = add_subp_cuts(opt, false, nothing)
            end
        end
    end

    if !subp_cuts_added
        # add separation cuts and update incumbent from OA solution if no cuts are added
        # TODO should check feas whether or not cuts are added, and accept incumbent if feas
        cuts_added = add_sep_cuts(opt)
        if !cuts_added
            # no separation cuts, so try updating incumbent from OA solver
            update_incumbent_from_OA(opt)
        end
    end

    # print and check convergence
    obj_rel_gap = get_obj_rel_gap(opt)
    if opt.verbose
        Printf.@printf(
            "%5d %8d %12.4e %12.4e %12.4e\n",
            opt.num_iters,
            opt.num_cuts,
            opt.obj_value,
            opt.obj_bound,
            obj_rel_gap,
        )
    end
    if !isnan(obj_rel_gap) && obj_rel_gap < opt.tol_rel_gap
        if opt.verbose
            println("objective relative gap $obj_rel_gap reached; terminating")
        end
        opt.status = MOI.OPTIMAL
        return true
    end
    obj_abs_gap = get_obj_abs_gap(opt)
    if !isnan(obj_abs_gap) && obj_abs_gap < opt.tol_abs_gap
        if opt.verbose
            println("objective absolute gap $obj_abs_gap reached; terminating")
        end
        opt.status = MOI.OPTIMAL
        return true
    end

    # check iteration limit
    if opt.num_iters == opt.iteration_limit
        if opt.verbose
            println("iteration limit ($(opt.num_iters)) reached; terminating")
        end
        opt.status = MOI.ITERATION_LIMIT
        return true
    end

    # set warm start from incumbent
    if opt.use_oa_starts && isfinite(opt.obj_value)
        oa_start = get_oa_start(opt, opt.incumbent)
        JuMP.set_start_value.(opt.oa_vars, oa_start)
    end
    return false
end

# one tree method using callbacks
function run_one_tree_method(opt::Optimizer)
    if opt.verbose
        println("starting one tree method")
    end
    oa_model = opt.oa_model
    if iszero(opt.num_int_vars) && isempty(opt.SOS12_cons)
        println(
            "model has no discrete variables, so adding a dummy integer variable",
        )
        dummy = JuMP.@variable(oa_model, integer = true)
    else
        dummy = nothing
    end

    function lazy_cb(cb)
        opt.num_lazy_cbs += 1
        opt.lazy_cb = cb
        int = (
            JuMP.callback_node_status(cb, oa_model) ==
            MOI.CALLBACK_NODE_STATUS_INTEGER
        )

        subp_cuts_added = false
        if opt.solve_subproblems
            # only solve subproblem at an integer solution
            int || return

            # check if integer solution is repeated and cache the cuts
            int_sol = get_integral_solution(opt)
            hash_int_sol = hash(int_sol)
            if haskey(opt.int_sols_cuts, hash_int_sol)
                # integral solution repeated: add cached cuts
                cuts = opt.int_sols_cuts[hash_int_sol]
                subp_cuts_added = add_cuts(cuts, opt, true)
                if !subp_cuts_added && opt.verbose
                    println("cached subproblem cuts could not be added")
                end
            else
                # new integral solution: solve subproblem, cache cuts, and add cuts
                cuts_cache = opt.int_sols_cuts[hash_int_sol] = JuMP.AffExpr[]
                subp_failed = solve_subproblem(int_sol, opt)
                if !subp_failed
                    subp_cuts_added = add_subp_cuts(opt, true, cuts_cache)
                end
            end
        end

        if !subp_cuts_added
            cuts_added = add_sep_cuts(opt)
            if !cuts_added && int
                # integer solution and no separation cuts added, so try updating incumbent
                update_incumbent_from_OA(opt)
            end
        end
        return
    end
    MOI.set(oa_model, MOI.LazyConstraintCallback(), lazy_cb)

    if opt.solve_subproblems
        function heuristic_cb(cb)
            opt.num_heuristic_cbs += 1
            opt.new_incumbent || return

            oa_start = get_oa_start(opt, opt.incumbent)
            status = MOI.submit(
                oa_model,
                MOI.HeuristicSolution(cb),
                opt.oa_vars,
                oa_start,
            )
            if opt.verbose
                println("heuristic cb status was: ", status)
            end
            opt.new_incumbent = false
            return
        end
        MOI.set(oa_model, MOI.HeuristicCallback(), heuristic_cb)
    end

    time_finish = check_set_time_limit(opt, oa_model)
    time_finish && return true
    JuMP.optimize!(oa_model)
    opt.lazy_cb = nothing

    oa_status = JuMP.termination_status(oa_model)
    if oa_status == MOI.OPTIMAL
        opt.status = oa_status
        opt.obj_bound = get_objective_bound(oa_model)

        if !isfinite(opt.obj_value)
            # use OA solver solution TODO should check feasibility
            @warn("taking OA solver solution, which may be infeasible")
            update_incumbent_from_OA(opt)
        end
    elseif oa_status == MOI.INFEASIBLE
        opt.status = oa_status
    elseif oa_status == MOI.TIME_LIMIT
        if opt.verbose
            println("OA solver timed out")
        end
        opt.status = oa_status
    else
        @warn("OA solver status $oa_status is not handled")
        opt.status = MOI.OTHER_ERROR
    end

    if !isnothing(dummy)
        # delete dummy integer constraint
        JuMP.delete(oa_model, dummy)
    end
    return
end

function solve_relaxation(opt::Optimizer)
    if opt.verbose
        println("solving continuous relaxation")
    end
    relax_model = opt.relax_model
    time_finish = check_set_time_limit(opt, relax_model)
    time_finish && return true
    JuMP.optimize!(relax_model)

    relax_status = JuMP.termination_status(relax_model)
    if opt.verbose
        println("continuous relaxation status is $relax_status")
    end
    if relax_status in (MOI.OPTIMAL, MOI.ALMOST_OPTIMAL)
        opt.obj_bound = JuMP.dual_objective_value(relax_model)
    elseif relax_status in (MOI.DUAL_INFEASIBLE, MOI.ALMOST_DUAL_INFEASIBLE)
        if opt.verbose
            println("problem could be unbounded; Pajarito may fail to converge")
        end
    elseif relax_status in (MOI.INFEASIBLE, MOI.ALMOST_INFEASIBLE)
        if opt.verbose
            println(
                "infeasibility detected from continuous relaxation; terminating",
            )
        end
        opt.status = MOI.INFEASIBLE
        return true
    elseif relax_status == MOI.TIME_LIMIT
        if opt.verbose
            println("continuous relaxation solver timed out")
        end
        opt.status = relax_status
        return true
    else
        @warn("continuous relaxation status $relax_status is not handled")
        return false
    end

    finish = false

    # check whether problem is continuous
    if iszero(opt.num_int_vars) && isempty(opt.SOS12_cons)
        if opt.verbose
            println("problem is continuous; terminating")
        end
        finish = true
    end

    if relax_status in (MOI.OPTIMAL, MOI.ALMOST_OPTIMAL)
        # check whether solution is feasible for integrality and SOS1/2 constraints
        if is_discrete_feas(opt, opt.relax_x)
            if opt.verbose
                println(
                    "relaxation solution satisfies discrete constraints; terminating",
                )
            end
            finish = true
        end
    end

    if finish
        if relax_status in (MOI.OPTIMAL, MOI.ALMOST_OPTIMAL)
            opt.status = MOI.OPTIMAL
            opt.obj_value = JuMP.objective_value(relax_model)
            opt.incumbent = JuMP.value.(opt.relax_x)
        elseif relax_status in (MOI.DUAL_INFEASIBLE, MOI.ALMOST_DUAL_INFEASIBLE)
            opt.status = MOI.DUAL_INFEASIBLE
        else
            error("status $(opt.status) not handled")
        end
        return true
    end
    return false
end

# solve subproblem with new integer variable sub-solution
function solve_subproblem(int_sol::Vector{Int}, opt::Optimizer)
    # update conic data for int_sol
    modify_subproblem(int_sol, opt)

    # solve
    subp_model = opt.subp_model
    time_finish = check_set_time_limit(opt, subp_model)
    time_finish && return true
    JuMP.optimize!(subp_model)

    subp_status = JuMP.termination_status(subp_model)
    if opt.verbose
        println("continuous subproblem status is $subp_status")
    end
    if subp_status in (MOI.OPTIMAL, MOI.ALMOST_OPTIMAL)
        obj_val =
            JuMP.objective_value(subp_model) +
            LinearAlgebra.dot(opt.c_int, int_sol)
        if obj_val < opt.obj_value
            # update incumbent and objective value
            subp_sol = JuMP.value.(opt.subp_x)
            opt.incumbent = vcat(int_sol, subp_sol)
            opt.obj_value = obj_val
            # println("new incumbent")
            opt.new_incumbent = true
        end
        return false
    elseif subp_status in (MOI.INFEASIBLE, MOI.ALMOST_INFEASIBLE)
        # NOTE: duals are rescaled before adding subproblem cuts
        return false
    elseif subp_status == MOI.TIME_LIMIT
        if opt.verbose
            println("continuous subproblem solver timed out")
        end
        opt.status = subp_status
        return true
    else
        @warn("continuous subproblem status $subp_status is not handled")
        return false
    end
end

# add separation cuts on primal rays of the continuous relaxation of the OA model
function run_oa_relax_bound(opt::Optimizer)
    # solve OA model
    time_finish = check_set_time_limit(opt, opt.oa_model)
    time_finish && return true
    JuMP.optimize!(opt.oa_model)

    pr_status = JuMP.primal_status(opt.oa_model)
    if pr_status in
       (MOI.INFEASIBILITY_CERTIFICATE, MOI.NEARLY_INFEASIBILITY_CERTIFICATE)
        # add separation cuts for primal ray
        cuts_added = add_sep_cuts(opt)
        cuts_added && return false
        @warn("continuous relaxation of OA model could not be bounded")
    end
    return true
end

# update incumbent from OA solver
function update_incumbent_from_OA(opt::Optimizer)
    sol = get_value(opt.oa_x, opt.lazy_cb)
    obj_val = LinearAlgebra.dot(opt.c, sol)
    if obj_val < opt.obj_value
        # update incumbent and objective value
        opt.incumbent = sol
        opt.obj_value = obj_val
        println("new incumbent")
        opt.new_incumbent = true
    end
    return
end

function get_integral_solution(opt::Optimizer)
    x_int = opt.oa_x[1:(opt.num_int_vars)]
    int_sol = get_value(x_int, opt.lazy_cb)

    # check solution is integral
    round_int_sol = round.(Int, int_sol)
    # TODO different tol option?
    if !isapprox(round_int_sol, int_sol, atol = opt.tol_feas)
        @warn("integer variable solution is not integral to tolerance tol_feas")
    end
    return round_int_sol
end

function is_discrete_feas(opt::Optimizer, vars::Vector{JuMP.VariableRef})
    # check whether solution is integral
    int_sol = JuMP.value.(vars[1:(opt.num_int_vars)])
    round_int_sol = round.(Int, int_sol)
    if !isapprox(round_int_sol, int_sol, atol = opt.tol_feas)
        return false
    end

    # check whether SOS1/2 constraints are satisfied
    for (idxs, si) in opt.SOS12_cons
        num_nz = count(i -> abs(JuMP.value(vars[i])) > opt.tol_feas, idxs)
        if num_nz > (si isa MOI.SOS1 ? 1 : 2)
            return false
        end
    end
    return true
end

# initialize and print
function start_optimize(opt::Optimizer)
    get_conic_opt(opt)
    get_oa_opt(opt)
    empty_optimize(opt)
    opt.solve_time = time()
    opt.obj_value = Inf
    opt.obj_bound = -Inf
    return
end

# finalize and print
function finish_optimize(opt::Optimizer)
    opt.solve_time = time() - opt.solve_time

    oa_status = MOI.get(opt.oa_opt, MOI.TerminationStatus())
    if opt.verbose && oa_status != MOI.OPTIMIZE_NOT_CALLED
        println(
            "OA solver finished with status $oa_status, after $(opt.solve_time) " *
            "seconds and $(opt.num_cuts) cuts",
        )
        if opt.use_iterative_method
            println("iterative method used $(opt.num_iters) iterations")
        else
            println(
                "one tree method used $(opt.num_lazy_cbs) lazy " *
                "callbacks and $(opt.num_heuristic_cbs) heuristic callbacks",
            )
        end
    end
    opt.verbose && println()
    return
end

# compute objective absolute gap
function get_obj_abs_gap(opt::Optimizer)
    if opt.obj_sense == MOI.FEASIBILITY_SENSE
        return NaN
    end
    return opt.obj_value - opt.obj_bound
end

# compute objective relative gap
function get_obj_rel_gap(opt::Optimizer)
    return get_obj_abs_gap(opt) / (1e-5 + abs(opt.obj_value))
end

# print iteration statistics column names
function print_header(opt::Optimizer)
    opt.verbose || return
    Printf.@printf(
        "%5s %8s %12s %12s %12s\n",
        "iter",
        "cuts",
        "obj",
        "bound",
        "gap"
    )
    return
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

module TestJuMP

using Test

import JuMP
import LinearAlgebra
import MathOptInterface as MOI
import Pajarito

function runtests(oa_solver, conic_solver)
    @testset "using conic solver" begin
        @testset "iterative method" begin
            run_jump_tests(true, true, oa_solver, conic_solver)
        end
        @testset "one tree method" begin
            run_jump_tests(false, true, oa_solver, conic_solver)
        end
    end
    @testset "using separation only" begin
        @testset "iterative method" begin
            run_jump_tests(true, false, oa_solver, conic_solver)
        end
        @testset "one tree method" begin
            run_jump_tests(false, false, oa_solver, conic_solver)
        end
    end
    return
end

function run_jump_tests(
    use_iter::Bool,
    solve_relax_subp::Bool,
    oa_solver,
    conic_solver,
)
    opt = JuMP.optimizer_with_attributes(
        Pajarito.Optimizer,
        "verbose" => true,
        # "verbose" => false,
        "use_iterative_method" => use_iter,
        "solve_relaxation" => solve_relax_subp,
        "solve_subproblems" => solve_relax_subp,
        "oa_solver" => oa_solver,
        "conic_solver" => conic_solver,
        "iteration_limit" => 100,
        # "time_limit" => 120.0,
    )
    insts = [
        _soc1,
        _soc2,
        _soc3,
        _exp1,
        _exp2,
        _pow1,
        _pow2,
        _psd1,
        _psd2,
        _expdesign,
        _specialorderedset,
        _soc1_ncuts,
    ]
    @testset "$inst" for inst in insts
        println(inst)
        inst(opt)
    end
    return
end

function _soc1(opt)
    TOL = 1e-4
    m = JuMP.Model(opt)

    JuMP.@variable(m, x)
    JuMP.@objective(m, Min, -x)
    xlb1 = JuMP.@constraint(m, x >= 4)
    soc1 = JuMP.@constraint(m, [3.5, x] in JuMP.SecondOrderCone())
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.INFEASIBLE
    @test JuMP.primal_status(m) == MOI.NO_SOLUTION

    JuMP.delete(m, xlb1)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), -3.5, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -3.5, atol = TOL)
    @test isapprox(JuMP.value(x), 3.5, atol = TOL)

    xlb2 = JuMP.@constraint(m, x >= 3.1)
    JuMP.set_integer(x)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.INFEASIBLE

    JuMP.delete(m, xlb2)
    JuMP.@constraint(m, x >= 0.5)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test isapprox(JuMP.objective_value(m), -3, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -3, atol = TOL)
    @test isapprox(JuMP.value(x), 3, atol = TOL)

    JuMP.@objective(m, Max, -3x)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test isapprox(JuMP.objective_value(m), -3, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -3, atol = TOL)
    @test isapprox(JuMP.value(x), 1, atol = TOL)

    JuMP.set_start_value(x, 1)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test isapprox(JuMP.objective_value(m), -3, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -3, atol = TOL)
    @test isapprox(JuMP.value(x), 1, atol = TOL)
    return
end

function _soc2(opt)
    TOL = 1e-4
    m = JuMP.Model(opt)

    JuMP.@variable(m, x)
    JuMP.@variable(m, y)
    JuMP.@variable(m, z, Int)
    JuMP.@constraint(m, z <= 2.5)
    JuMP.@objective(m, Min, x + 2y)
    JuMP.@constraint(m, [z, x, y] in JuMP.SecondOrderCone())
    JuMP.set_integer(x)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    opt_obj = -1 - 2 * sqrt(3)
    @test isapprox(JuMP.objective_value(m), opt_obj, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), opt_obj, atol = TOL)
    @test isapprox(JuMP.value(x), -1, atol = TOL)
    @test isapprox(JuMP.value(y), -sqrt(3), atol = TOL)
    @test isapprox(JuMP.value(z), 2, atol = TOL)

    JuMP.unset_integer(x)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    opt_obj = -2 * sqrt(5)
    @test isapprox(JuMP.objective_value(m), opt_obj, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), opt_obj, atol = TOL)
    @test isapprox(abs2(JuMP.value(x)) + abs2(JuMP.value(y)), 4, atol = TOL)
    @test isapprox(JuMP.value(z), 2, atol = TOL)
    return
end

function _soc3(opt)
    TOL = 1e-4
    m = JuMP.Model(opt)
    JuMP.@variable(m, x[1:3], Bin)
    # JuMP.set_start_value.(x, 1) # infeasible
    soc = JuMP.@constraint(
        m,
        vcat(inv(sqrt(2)), x .- 0.5) in JuMP.SecondOrderCone()
    )
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.INFEASIBLE
    @test JuMP.primal_status(m) == MOI.NO_SOLUTION

    JuMP.@objective(m, Min, 1 + sum(x))
    JuMP.delete(m, soc)
    JuMP.@constraint(m, vcat(1.5, x .- 1) in JuMP.SecondOrderCone())
    JuMP.set_start_value.(x, [1, 0, 0])
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 2, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 2, atol = TOL)
    return
end

function _exp1(opt)
    TOL = 1e-4
    m = JuMP.Model(opt)

    (u, v, w) = s = JuMP.@variable(m, [1:3])
    JuMP.set_binary(v)
    JuMP.@objective(m, Max, u)
    JuMP.@constraint(m, s in MOI.ExponentialCone())
    JuMP.@constraint(m, 1 / 2 - u - v >= 0)
    c1 = JuMP.@constraint(m, w <= 1e5)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 0, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 0, atol = TOL)
    @test isapprox(JuMP.value(v), 0, atol = TOL)

    JuMP.delete(m, c1)
    JuMP.@objective(m, Max, u - w)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 0, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 0, atol = TOL)
    @test isapprox(JuMP.value(w), 0, atol = TOL)
    return
end

function _exp2(opt)
    TOL = 1e-4
    m = JuMP.Model(opt)

    JuMP.@variable(m, x >= 0, Int)
    JuMP.@variable(m, y >= 0)
    JuMP.@objective(m, Min, -3x - y)
    JuMP.@constraint(m, 3x + 2y <= 10)
    c1 = JuMP.@constraint(m, [x, 1, 10] in MOI.ExponentialCone())
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), -8, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -8, atol = TOL)
    @test isapprox(JuMP.value(x), 2, atol = TOL)
    @test isapprox(JuMP.value(y), 2, atol = TOL)

    JuMP.delete(m, c1)
    JuMP.@constraint(m, [x, -1, 10] in MOI.ExponentialCone())
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.INFEASIBLE
    @test JuMP.primal_status(m) == MOI.NO_SOLUTION
    return
end

function _pow1(opt)
    TOL = 1e-3
    m = JuMP.Model(opt)

    JuMP.@variable(m, x)
    JuMP.@variable(m, y)
    JuMP.@variable(m, z)
    JuMP.@constraint(m, z >= 0.5)
    JuMP.@objective(m, Min, x + 2y)
    JuMP.@constraint(m, [x, y, z] in MOI.PowerCone(0.5))
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    rt2 = sqrt(2)
    @test isapprox(JuMP.objective_value(m), rt2, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), rt2, atol = TOL)
    @test isapprox(JuMP.value(x), rt2 / 2, atol = TOL)
    @test isapprox(JuMP.value(y), rt2 / 4, atol = TOL)
    @test isapprox(JuMP.value(z), 0.5, atol = TOL)

    JuMP.set_integer(x)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 1.5, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 1.5, atol = TOL)
    @test isapprox(JuMP.value(x), 1, atol = TOL)
    @test isapprox(JuMP.value(y), 0.25, atol = TOL)

    JuMP.set_integer(z)
    JuMP.@objective(m, Min, x + 3y)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 3.5, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 3.5, atol = TOL)
    @test isapprox(JuMP.value(x), 2, atol = TOL)
    @test isapprox(JuMP.value(y), 0.5, atol = TOL)
    @test isapprox(JuMP.value(z), 1, atol = TOL)
    return
end

function _pow2(opt)
    TOL = 1e-4
    m = JuMP.Model(opt)
    JuMP.@variable(m, x[1:3])
    JuMP.@variable(m, y[1:3], Bin)
    JuMP.@constraint(
        m,
        [i in 1:3],
        [x[i] / 3, 1, y[i] - 0.5] in MOI.PowerCone(1 / 3)
    )
    c1 = JuMP.@constraint(m, sum(x) <= 1)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.INFEASIBLE
    @test JuMP.primal_status(m) == MOI.NO_SOLUTION

    JuMP.delete(m, c1)
    JuMP.@objective(m, Min, sum(x))
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 9 / 8, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 9 / 8, atol = TOL)
    @test isapprox(JuMP.value.(x), fill(3 / 8, 3), atol = TOL)
    y_val = JuMP.value.(y)
    @test isapprox(y_val, round.(y_val), atol = TOL)
    return
end

function _psd1(opt)
    TOL = 1e-4
    m = JuMP.Model(opt)

    JuMP.@variable(m, x, Int)
    JuMP.@constraint(m, x >= 0)
    JuMP.@variable(m, y >= 0)
    JuMP.@variable(m, Z[1:2, 1:2], PSD)
    JuMP.@objective(m, Max, 3x + y - Z[1, 1])
    JuMP.@constraint(m, 3x + 2y <= 10)
    JuMP.@constraint(m, [2 x; x 2] in JuMP.PSDCone())
    c1 = JuMP.@constraint(m, Z[1, 2] >= 1)
    c2 = JuMP.@constraint(m, y >= Z[2, 2])
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 7.5, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 7.5, atol = TOL)
    @test isapprox(JuMP.value(x), 2, atol = TOL)
    @test isapprox(JuMP.value(y), 2, atol = TOL)
    @test isapprox(JuMP.value.(vec(Z)), [0.5, 1, 1, 2], atol = TOL)

    JuMP.delete(m, c1)
    JuMP.delete(m, c2)
    JuMP.@constraint(m, x >= 2)
    JuMP.set_lower_bound(Z[1, 2], 2)
    c2 = JuMP.@constraint(m, y >= Z[2, 2] + Z[1, 1])
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.INFEASIBLE
    @test JuMP.primal_status(m) == MOI.NO_SOLUTION
    return
end

function _psd2(opt)
    TOL = 1e-4
    d = 3
    mat = LinearAlgebra.Symmetric(Matrix{Float64}(reshape(1:(d^2), d, d)), :U)
    λ₁ = LinearAlgebra.eigmax(mat)
    m = JuMP.Model(opt)

    X = JuMP.@variable(m, [1:d, 1:d], PSD)
    JuMP.@objective(m, Max, LinearAlgebra.dot(mat, X))
    JuMP.@constraint(m, LinearAlgebra.tr(X) == 1)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), λ₁, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), λ₁, atol = TOL)
    X_val = JuMP.value.(X)
    @test isapprox(LinearAlgebra.tr(X_val), 1, atol = TOL)

    JuMP.set_binary.(X)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), mat[d, d], atol = TOL)
    @test isapprox(JuMP.objective_bound(m), mat[d, d], atol = TOL)
    X_val = JuMP.value.(X)
    @test isapprox(sum(X_val), 1, atol = TOL)
    @test isapprox(X_val[d, d], 1, atol = TOL)
    return
end

function _expdesign(opt)
    TOL = 1e-4
    # experiment design
    V = [1 1 -0.2 -0.5; 1 -1 0.5 -0.2]
    function setup_exp_design()
        m = JuMP.Model(opt)
        JuMP.@variable(m, x[1:4], Int)
        JuMP.@constraint(m, x[1:2] .>= 1) # avoids ill-posedness
        JuMP.@constraint(m, x[3:4] .>= 0)
        JuMP.@constraint(m, sum(x) <= 8)
        Q = V * LinearAlgebra.diagm(x) * V'
        return (m, x, Q)
    end

    # A-optimal
    (m, x, Q) = setup_exp_design()
    JuMP.set_start_value.(x, [4, 4, 0, 0]) # partial warm start
    JuMP.@variable(m, y[1:2])
    JuMP.@objective(m, Min, sum(y))
    for i in 1:2
        ei = zeros(2)
        ei[i] = 1
        Qyi = [Q ei; ei' y[i]]
        JuMP.@constraint(m, LinearAlgebra.Symmetric(Qyi) in JuMP.PSDCone())
    end
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 1 / 4, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 1 / 4, atol = TOL)
    x_val = JuMP.value.(x)
    @test isapprox(x_val, [4, 4, 0, 0], atol = TOL)
    @test isapprox(JuMP.value.(y[1]), JuMP.value.(y[2]), atol = TOL)

    # E-optimal
    (m, x, Q) = setup_exp_design()
    JuMP.@variable(m, y)
    JuMP.set_start_value.(vcat(x, y), [4, 4, 0, 0, 8]) # full warm start
    JuMP.@objective(m, Max, y)
    Qy = Q - y * Matrix(LinearAlgebra.I, 2, 2)
    JuMP.@constraint(m, LinearAlgebra.Symmetric(Qy) in JuMP.PSDCone())
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), 8, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), 8, atol = TOL)
    x_val = JuMP.value.(x)
    @test isapprox(x_val, [4, 4, 0, 0], atol = TOL)

    # D-optimal
    for use_logdet in (true, false)
        opt_x = [4, 4, 0, 0]
        opt_Q = LinearAlgebra.Symmetric(V * LinearAlgebra.Diagonal(opt_x) * V')
        (m, x, Q) = setup_exp_design()
        JuMP.@variable(m, y)
        JuMP.@objective(m, Max, y)
        Qvec = [Q[1, 1], Q[2, 1], Q[2, 2]]
        if use_logdet
            JuMP.@constraint(m, vcat(y, 1.0, Qvec) in MOI.LogDetConeTriangle(2))
            opt_val = LinearAlgebra.logdet(opt_Q)
        else
            JuMP.@constraint(m, vcat(y, Qvec) in MOI.RootDetConeTriangle(2))
            opt_val = sqrt(LinearAlgebra.det(opt_Q))
        end
        JuMP.optimize!(m)
        @test JuMP.termination_status(m) == MOI.OPTIMAL
        @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
        @test isapprox(JuMP.objective_value(m), opt_val, atol = TOL)
        @test isapprox(JuMP.objective_bound(m), opt_val, atol = TOL)
        x_val = JuMP.value.(x)
        @test isapprox(x_val, opt_x, atol = TOL)
    end
    return
end

function _specialorderedset(opt)
    TOL = 1e-4
    for (S, sol) in [(MOI.SOS1, [1, 0, 0]), (MOI.SOS2, [1, 1, 0])]
        if !MOI.supports_constraint(
            MOI.instantiate(opt),
            MOI.VectorOfVariables,
            S{Float64},
        )
            # only test if Pajarito supports SOS1/2
            continue
        end
        m = JuMP.Model(opt)

        JuMP.@variable(m, u)
        JuMP.@variable(m, w[1:3])
        w0 = w + [1.1, 2.3, 3.5]
        JuMP.@constraint(m, vcat(u, w0) in MOI.GeometricMeanCone(4))
        JuMP.@objective(m, Max, u)
        JuMP.@constraint(m, w .<= 1.5)
        JuMP.@constraint(m, w in S([1.0, 2, 3]))
        JuMP.optimize!(m)

        @test JuMP.termination_status(m) == MOI.OPTIMAL
        @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
        opt_obj = prod(JuMP.value.(w0))^(1 // 3)
        @test isapprox(JuMP.objective_value(m), opt_obj, atol = TOL)
        @test isapprox(JuMP.objective_bound(m), opt_obj, atol = TOL)
        @test isapprox(JuMP.value(u), opt_obj, atol = TOL)
        @test isapprox(JuMP.value.(w), 1.5 * sol, atol = TOL)

        JuMP.set_integer.(w)
        JuMP.optimize!(m)
        @test JuMP.termination_status(m) == MOI.OPTIMAL
        @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
        opt_obj = prod(JuMP.value.(w0))^(1 // 3)
        @test isapprox(JuMP.objective_value(m), opt_obj, atol = TOL)
        @test isapprox(JuMP.objective_bound(m), opt_obj, atol = TOL)
        @test isapprox(JuMP.value(u), opt_obj, atol = TOL)
        @test isapprox(JuMP.value.(w), sol, atol = TOL)
    end
    return
end

function _soc1_ncuts(opt)
    TOL = 1e-4
    m = JuMP.Model(opt)

    JuMP.@variable(m, x)
    JuMP.@objective(m, Min, -x)
    xlb1 = JuMP.@constraint(m, x >= 4)
    soc1 = JuMP.@constraint(m, [3.5, x] in JuMP.SecondOrderCone())
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.INFEASIBLE
    @test JuMP.primal_status(m) == MOI.NO_SOLUTION

    JuMP.delete(m, xlb1)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test JuMP.primal_status(m) == MOI.FEASIBLE_POINT
    @test isapprox(JuMP.objective_value(m), -3.5, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -3.5, atol = TOL)
    @test isapprox(JuMP.value(x), 3.5, atol = TOL)

    xlb2 = JuMP.@constraint(m, x >= 3.1)
    JuMP.set_integer(x)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.INFEASIBLE

    JuMP.delete(m, xlb2)
    JuMP.@constraint(m, x >= 0.5)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test MOI.get(m, Pajarito.NumberOfCuts()) > 0
    @test isapprox(JuMP.objective_value(m), -3, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -3, atol = TOL)
    @test isapprox(JuMP.value(x), 3, atol = TOL)

    JuMP.@objective(m, Max, -3x)
    JuMP.optimize!(m)
    @test MOI.get(m, Pajarito.NumberOfCuts()) > 0
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test isapprox(JuMP.objective_value(m), -3, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -3, atol = TOL)
    @test isapprox(JuMP.value(x), 1, atol = TOL)

    JuMP.set_start_value(x, 1)
    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == MOI.OPTIMAL
    @test MOI.get(m, Pajarito.NumberOfCuts()) > 0
    @test isapprox(JuMP.objective_value(m), -3, atol = TOL)
    @test isapprox(JuMP.objective_bound(m), -3, atol = TOL)
    @test isapprox(JuMP.value(x), 1, atol = TOL)
    return
end

end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# CBF instance tests

module TestCBF

using Test

import MathOptInterface as MOI
import Pajarito

function runtests(oa_solver, conic_solver)
    @testset "iterative method" begin
        run_cbf_tests(true, oa_solver, conic_solver)
    end
    @testset "one tree method" begin
        run_cbf_tests(false, oa_solver, conic_solver)
    end
    return
end

function run_cbf_tests(use_iter::Bool, oa_solver, conic_solver)
    model = MOI.Bridges.full_bridge_optimizer(
        MOI.Utilities.CachingOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
            Pajarito.Optimizer(),
        ),
        Float64,
    )
    MOI.set(model, MOI.Silent(), true)
    MOI.set(model, MOI.RawOptimizerAttribute("use_iterative_method"), use_iter)
    MOI.set(model, MOI.RawOptimizerAttribute("oa_solver"), oa_solver)
    MOI.set(model, MOI.RawOptimizerAttribute("conic_solver"), conic_solver)
    MOI.set(model, MOI.RawOptimizerAttribute("time_limit"), 60)
    MOI.set(model, MOI.RawOptimizerAttribute("iteration_limit"), 100)

    insts = ["sssd_strong_15_4", "exp_ising", "sdp_cardls"]
    folder = joinpath(@__DIR__, "CBF")

    @testset "$inst" for inst in insts
        println(inst)
        file = joinpath(folder, string(inst, ".cbf"))
        run_cbf(model, file)
        getfield(@__MODULE__, Symbol(inst))(model)
    end
    return
end

function run_cbf(model, file::String)
    MOI.empty!(model)
    src = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_CBF)
    MOI.read_from_file(src, file)
    MOI.copy_to(model, src)
    MOI.optimize!(model)
    return model
end

function sssd_strong_15_4(model)
    @test MOI.get(model, MOI.TerminationStatus()) in
          (MOI.TIME_LIMIT, MOI.OPTIMAL)
    return
end

function exp_ising(model)
    TOL = 1e-4
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMAL
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), 0.696499, atol = TOL)
    @test isapprox(MOI.get(model, MOI.ObjectiveBound()), 0.696499, atol = TOL)
    return
end

function sdp_cardls(model)
    TOL = 1e-4
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMAL
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), 16.045564, atol = TOL)
    @test isapprox(MOI.get(model, MOI.ObjectiveBound()), 16.045564, atol = TOL)
    return
end

end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# tools for JuMP functions

function add_cuts(cuts::Vector{JuMP.AffExpr}, opt::Optimizer, viol_only::Bool)
    if viol_only
        # filter out unviolated cuts
        cuts = filter(cut -> get_value(cut, opt.lazy_cb) < -opt.tol_feas, cuts)
    end

    _add_cuts(cuts, opt.oa_model, opt.lazy_cb)
    opt.num_cuts += length(cuts)
    return !isempty(cuts)
end

function _add_cuts(cuts::Vector{JuMP.AffExpr}, model::JuMP.Model, ::Nothing)
    JuMP.@constraint(model, cuts .>= 0)
    return
end

function _add_cuts(cuts::Vector{JuMP.AffExpr}, model::JuMP.Model, cb)
    cons = JuMP.@build_constraint(cuts .>= 0)
    MOI.submit.(model, MOI.LazyConstraint(cb), cons)
    return
end

function get_value(expr::Union{JuMP.VariableRef,JuMP.AffExpr}, ::Nothing)
    return JuMP.value(expr)
end

function get_value(expr::Union{JuMP.VariableRef,JuMP.AffExpr}, cb)
    return JuMP.callback_value(cb, expr)
end

function get_value(exprs::Vector{<:Union{JuMP.VariableRef,JuMP.AffExpr}}, cb)
    return [get_value(e, cb) for e in exprs]
end

function check_set_time_limit(opt::Optimizer, model::JuMP.Model)
    time_left = opt.time_limit - time() + opt.solve_time
    if time_left < 1e-3
        if opt.verbose
            println("time limit ($(opt.time_limit)) reached; terminating")
        end
        opt.status = MOI.TIME_LIMIT
        return true
    end
    if MOI.supports(JuMP.backend(model), MOI.TimeLimitSec())
        JuMP.set_time_limit_sec(model, time_left)
    end
    return false
end

# try to get an objective bound or dual objective value, else use the primal objective value
function get_objective_bound(model::JuMP.Model)
    try
        return JuMP.objective_bound(model)
    catch
    end
    try
        return JuMP.dual_objective_value(model)
    catch
    end
    return JuMP.objective_value(model)
end

# get number of constraints of all types
function get_num_constraints(model::JuMP.Model)
    num_cons = 0
    for (F, S) in JuMP.list_of_constraint_types(model)
        num_cons += JuMP.num_constraints(model, F, S)
    end
    return num_cons
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

_is_empty(::Nothing) = true
_is_empty(opt::MOI.AbstractOptimizer) = MOI.is_empty(opt)

function MOI.is_empty(opt::Optimizer)
    return _is_empty(opt.oa_opt) && _is_empty(opt.conic_opt)
end

MOI.empty!(opt::Optimizer) = empty_optimize(opt)

MOI.get(::Optimizer, ::MOI.SolverName) = "Pajarito"

MOI.get(opt::Optimizer, ::MOI.RawSolver) = opt

MOI.supports(::Optimizer, ::MOI.Silent) = true

function MOI.set(opt::Optimizer, ::MOI.Silent, value::Bool)
    opt.verbose = !value
    return
end

MOI.get(opt::Optimizer, ::MOI.Silent) = !opt.verbose

MOI.supports(::Optimizer, ::MOI.TimeLimitSec) = true

function MOI.set(opt::Optimizer, ::MOI.TimeLimitSec, value::Union{Real,Nothing})
    opt.time_limit = something(value, Inf)
    return
end

function MOI.get(opt::Optimizer, ::MOI.TimeLimitSec)
    if isfinite(opt.time_limit)
        return opt.time_limit
    end
    return
end

function MOI.get(opt::Optimizer, ::MOI.SolveTimeSec)
    if isnan(opt.solve_time)
        error("solve has not been called")
    end
    return opt.solve_time
end

MOI.get(opt::Optimizer, ::MOI.RawStatusString) = string(opt.status)

function MOI.set(opt::Optimizer, param::MOI.RawOptimizerAttribute, value)
    return setproperty!(opt, Symbol(param.name), value)
end

function MOI.get(opt::Optimizer, param::MOI.RawOptimizerAttribute)
    return getproperty(opt, Symbol(param.name))
end

function MOI.supports(
    ::Optimizer,
    ::Union{
        MOI.ObjectiveSense,
        MOI.ObjectiveFunction{
            <:Union{MOI.VariableIndex,MOI.ScalarAffineFunction{Float64}},
        },
    },
)
    return true
end

function MOI.supports_constraint(
    opt::Optimizer,
    F::Type{MOI.VariableIndex},
    S::Type{MOI.Integer},
)
    return MOI.supports_constraint(get_oa_opt(opt), F, S)
end

# if not solving conic subproblems, allow SOS1/2 constraints if supported by OA solver
function MOI.supports_constraint(
    opt::Optimizer,
    F::Type{MOI.VectorOfVariables},
    S::Type{<:Union{MOI.SOS1{Float64},MOI.SOS2{Float64}}},
)
    return !opt.solve_subproblems &&
           MOI.supports_constraint(get_oa_opt(opt), F, S)
end

# if using conic solver, cone must be supported by both Pajarito and the conic solver
function MOI.supports_constraint(
    opt::Optimizer,
    F::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{Float64}}},
    S::Type{<:Union{MOI.Zeros,MOI.Nonnegatives,Cones.OACone}},
)
    if !(opt.solve_relaxation || opt.solve_subproblems)
        return true
    end
    return MOI.supports_constraint(get_conic_opt(opt), F, S)
end

function MOI.supports(
    ::Optimizer,
    ::MOI.VariablePrimalStart,
    ::Type{MOI.VariableIndex},
)
    return true
end

MOI.optimize!(opt::Optimizer) = optimize(opt)

MOI.get(opt::Optimizer, ::MOI.TerminationStatus) = opt.status

function MOI.get(opt::Optimizer, attr::MOI.PrimalStatus)
    if attr.result_index != 1
        return MOI.NO_SOLUTION
    end
    term_status = MOI.get(opt, MOI.TerminationStatus())
    if term_status == MOI.OPTIMAL
        return MOI.FEASIBLE_POINT
    elseif term_status == MOI.ALMOST_OPTIMAL
        return MOI.NEARLY_FEASIBLE_POINT
    end
    return MOI.NO_SOLUTION
end

MOI.get(::Optimizer, ::MOI.DualStatus) = MOI.NO_SOLUTION

function _adjust_obj(opt::Optimizer, value::Float64)
    sense_mul = (opt.obj_sense == MOI.MAX_SENSE ? -1 : 1)
    return sense_mul * (opt.obj_offset + value)
end

function MOI.get(opt::Optimizer, attr::MOI.ObjectiveValue)
    MOI.check_result_index_bounds(opt, attr)
    return _adjust_obj(opt, opt.obj_value)
end

MOI.get(opt::Optimizer, ::MOI.ObjectiveBound) = _adjust_obj(opt, opt.obj_bound)

MOI.get(opt::Optimizer, ::MOI.RelativeGap) = get_obj_rel_gap(opt)

MOI.get(opt::Optimizer, ::MOI.ResultCount) = 1

function MOI.get(
    opt::Optimizer,
    attr::MOI.VariablePrimal,
    vi::MOI.VariableIndex,
)
    MOI.check_result_index_bounds(opt, attr)
    return opt.incumbent[vi.value]
end

function MOI.get(opt::Optimizer, ::MOI.NodeCount)
    return MOI.get(opt.oa_model, MOI.NodeCount())
end

"""
    NumberOfCuts

Number of cuts added to the outer approximation model.
"""
struct NumberOfCuts <: MOI.AbstractModelAttribute end

MOI.attribute_value_type(::NumberOfCuts) = Int64
MOI.is_set_by_optimize(::NumberOfCuts) = true

function MOI.get(opt::Optimizer, ::NumberOfCuts)
    return opt.num_cuts
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# cut oracles for MathOptInterface cones

module Cones

import LinearAlgebra
import JuMP
import MathOptInterface as MOI

import Pajarito: Cache, Optimizer

abstract type NatExt end
struct Nat <: NatExt end
struct Ext <: NatExt end
function nat_or_ext(opt::Optimizer, d::Int)
    return ((d > 1 && opt.use_extended_form) ? Ext : Nat)
end

include("secondordercone.jl")
include("exponentialcone.jl")
include("powercone.jl")
include("positivesemidefiniteconetriangle.jl")

# supported cones for outer approximation
const OACone = Union{
    MOI.SecondOrderCone,
    MOI.ExponentialCone,
    MOI.PowerCone{Float64},
    MOI.PositiveSemidefiniteConeTriangle,
}

setup_auxiliary(::Cache, ::Optimizer) = JuMP.VariableRef[]

extend_start(::Cache, ::Vector{Float64}, ::Optimizer) = Float64[]

num_ext_variables(::Cache) = 0

function dot_expr(
    z::AbstractVecOrMat{Float64},
    vars::AbstractVecOrMat{<:Union{JuMP.VariableRef,JuMP.AffExpr}},
    opt::Optimizer,
)
    return JuMP.@expression(opt.oa_model, LinearAlgebra.dot(z, vars))
end

function clean_array!(z::AbstractArray)
    # avoid poorly conditioned cuts and near-zero values
    z_norm = LinearAlgebra.norm(z, Inf)
    min_abs = max(1e-12, 1e-15 * z_norm) # TODO tune/option
    for (i, z_i) in enumerate(z)
        if abs(z_i) < min_abs
            z[i] = 0
        end
    end
    return iszero(z)
end

get_oa_s(cache::Cache) = cache.oa_s

end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

#=
positive semidefinite cone triangle (unscaled)
w ⪰ 0
=#

mutable struct PositiveSemidefiniteConeTriangle <: Cache
    oa_s::Vector{JuMP.AffExpr}
    d::Int
    W::Matrix{<:Union{JuMP.VariableRef,JuMP.AffExpr}}
    PositiveSemidefiniteConeTriangle() = new()
end

function create_cache(
    oa_s::Vector{JuMP.AffExpr},
    moi_cone::MOI.PositiveSemidefiniteConeTriangle,
    ::Optimizer,
)
    cache = PositiveSemidefiniteConeTriangle()
    cache.oa_s = oa_s
    cache.d = moi_cone.side_dimension
    cache.W = vec_to_symm(cache.d, oa_s)
    return cache
end

function add_init_cuts(cache::PositiveSemidefiniteConeTriangle, opt::Optimizer)
    # add variable bounds W_ii ≥ 0, ∀i
    d = cache.d
    W = cache.W
    JuMP.@constraint(opt.oa_model, [i in 1:d], W[i, i] >= 0)
    opt.use_init_fixed_oa || return

    # add cuts (1, 1, ±2) on (W_ii, W_jj, W_ij), ∀i != j
    # (a linearization of W_ii * W_jj ≥ W_ij^2)
    # initial OA polyhedron is the dual cone of diagonally dominant matrices
    for j in 1:d, i in 1:(j-1)
        Wii = W[i, i]
        Wjj = W[j, j]
        Wij = W[i, j]
        JuMP.@constraints(opt.oa_model, begin
            Wii + Wjj + 2 * Wij >= 0
            Wii + Wjj - 2 * Wij >= 0
        end)
    end
    return
end

function get_subp_cuts(
    z::Vector{Float64},
    cache::PositiveSemidefiniteConeTriangle,
    opt::Optimizer,
)
    # strengthened cuts from eigendecomposition are λᵢ * rᵢ * rᵢ'
    R = vec_to_symm(cache.d, z)
    F = LinearAlgebra.eigen!(LinearAlgebra.Symmetric(R, :U), 1e-9, Inf)
    isempty(F.values) && return JuMP.AffExpr[]
    R_eig = F.vectors * LinearAlgebra.Diagonal(sqrt.(F.values))
    return _get_cuts(R_eig, cache, opt)
end

function get_sep_cuts(
    s::Vector{Float64},
    cache::PositiveSemidefiniteConeTriangle,
    opt::Optimizer,
)
    # check s ∉ K
    sW = vec_to_symm(cache.d, s)
    F = LinearAlgebra.eigen!(
        LinearAlgebra.Symmetric(sW, :U),
        -Inf,
        -opt.tol_feas,
    )
    isempty(F.values) && return JuMP.AffExpr[]
    return _get_cuts(F.vectors, cache, opt)
end

function _get_cuts(
    R_eig::Matrix{Float64},
    cache::PositiveSemidefiniteConeTriangle,
    opt::Optimizer,
)
    # cuts from eigendecomposition are rᵢ * rᵢ'
    W = cache.W
    cuts = JuMP.AffExpr[]
    for i in 1:size(R_eig, 2)
        @views r_i = R_eig[:, i]
        R_i = r_i * r_i'
        clean_array!(R_i) && continue
        cut = dot_expr(R_i, W, opt)
        push!(cuts, cut)
    end
    return cuts
end

function vec_to_symm(d::Int, vec::Vector{T}) where {T}
    mat = Matrix{T}(undef, d, d)
    k = 1
    for j in 1:d
        for i in 1:(j-1)
            mat[i, j] = mat[j, i] = vec[k]
            k += 1
        end
        mat[j, j] = vec[k]
        k += 1
    end
    @assert k - 1 == length(vec)
    return mat
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

module TestMOI

using Test

import MathOptInterface as MOI
import Pajarito

function runtests(oa_solver, conic_solver)
    @testset "solving conic subproblems" begin
        @testset "iterative method" begin
            run_moi_tests(true, true, oa_solver, conic_solver)
        end
        @testset "one tree method" begin
            run_moi_tests(false, true, oa_solver, conic_solver)
        end
    end
    @testset "not solving conic subproblems" begin
        @testset "iterative method" begin
            run_moi_tests(true, false, oa_solver, conic_solver)
        end
        @testset "one tree method" begin
            run_moi_tests(false, false, oa_solver, conic_solver)
        end
    end
    return
end

function run_moi_tests(
    use_iter::Bool,
    solve_subp::Bool,
    oa_solver,
    conic_solver,
)
    model = MOI.Bridges.full_bridge_optimizer(
        MOI.Utilities.CachingOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
            Pajarito.Optimizer(),
        ),
        Float64,
    )
    MOI.set(model, MOI.Silent(), true)
    MOI.set(model, MOI.RawOptimizerAttribute("use_iterative_method"), use_iter)
    MOI.set(model, MOI.RawOptimizerAttribute("solve_subproblems"), solve_subp)
    MOI.set(model, MOI.RawOptimizerAttribute("oa_solver"), oa_solver)
    MOI.set(model, MOI.RawOptimizerAttribute("conic_solver"), conic_solver)
    MOI.set(model, MOI.RawOptimizerAttribute("iteration_limit"), 100)
    MOI.Test.runtests(
        model,
        MOI.Test.Config(
            Float64,
            atol = 2e-4,
            rtol = 2e-4,
            exclude = Any[
                MOI.ConstraintDual,
                MOI.ConstraintBasisStatus,
                MOI.VariableBasisStatus,
                MOI.DualObjectiveValue,
                MOI.SolverVersion,
            ],
        ),
        exclude = String[
            # TODO: unexpected failures, probably in the bridge layer
            "test_model_UpperBoundAlreadySet",
            "test_model_LowerBoundAlreadySet",
            # TODO: errors bridging to MILP with GLPK
            "_Indicator_",
            "_SOS1_",
            "_SOS2_",
        ],
    )
    return
end

end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

#=
exponential cone
(u, v, w) : (u ≤ 0, v = 0, w ≥ 0) or (v > 0, w ≥ v * exp(u / v))
equivalently (v > 0, u ≤ v * log(w / v))
dual cone
(p, q, r) : (p = 0, q ≥ 0, r ≥ 0) or (p < 0, r ≥ -p * exp(q / p - 1))
equivalently (p < 0, q ≥ p * (log(r / -p) + 1))
=#

mutable struct ExponentialCone <: Cache
    oa_s::Vector{JuMP.AffExpr}
    ExponentialCone() = new()
end

function create_cache(
    oa_s::Vector{JuMP.AffExpr},
    ::MOI.ExponentialCone,
    ::Optimizer,
)
    @assert length(oa_s) == 3
    cache = ExponentialCone()
    cache.oa_s = oa_s
    return cache
end

function add_init_cuts(cache::ExponentialCone, opt::Optimizer)
    # add variable bounds
    (u, v, w) = cache.oa_s
    JuMP.@constraint(opt.oa_model, v >= 0)
    JuMP.@constraint(opt.oa_model, w >= 0)
    opt.use_init_fixed_oa || return

    # add cuts from linearizations at p = -1
    r_lin = [1e-3, 1e0, 1e2]
    JuMP.@constraint(
        opt.oa_model,
        [r in r_lin],
        -u - (log(r) + 1) * v + r * w >= 0
    )
    return
end

function get_subp_cuts(
    z::Vector{Float64},
    cache::ExponentialCone,
    opt::Optimizer,
)
    p = z[1]
    r = z[3]
    if p > 0 || r < 0
        # z ∉ K
        @warn("exponential cone dual vector violates variable bounds")
        return JuMP.AffExpr[]
    end
    q = z[2]
    (u, v, w) = cache.oa_s

    if p > -1e-12
        return JuMP.AffExpr[]
    elseif r / -p > 1e-8
        # strengthened cut is (p, p * (log(r / -p) + 1), r)
        q = p * (log(r / -p) + 1)
        cut = JuMP.@expression(opt.oa_model, p * u + q * v + r * w)
    elseif q / p < 30
        # strengthened cut is (p, q, -p * exp(q / p - 1))
        r = -p * exp(q / p - 1)
        cut = JuMP.@expression(opt.oa_model, p * u + q * v + r * w)
    else
        return JuMP.AffExpr[]
    end
    return [cut]
end

function get_sep_cuts(
    s::Vector{Float64},
    cache::ExponentialCone,
    opt::Optimizer,
)
    us = s[1]
    vs = max(s[2], 0)
    ws = max(s[3], 0)
    (u, v, w) = cache.oa_s

    # check s ∉ K and add cut
    if vs <= 1e-7
        # vs near zero, so violation is us
        if us >= opt.tol_feas
            if ws <= 1e-12
                @warn("cannot add separation cut for exponential cone")
            end

            # cut is (-1, -log(ℯ / 2 * us / ws), us / ws / 2)
            r = us / (2 * ws)
            q = -log(ℯ / 2 * r)
            cut = JuMP.@expression(opt.oa_model, -u + q * v + r * w)
        else
            return JuMP.AffExpr[]
        end
    elseif ws / vs > 1e-8 && us - vs * log(ws / vs) > opt.tol_feas
        # vs and ws not near zero
        # gradient cut is (-1, log(ws / vs) - 1, vs / ws)
        q = log(ws / vs) - 1
        cut = JuMP.@expression(opt.oa_model, -u + q * v + vs / ws * w)
    elseif vs * exp(us / vs) - ws > opt.tol_feas
        # gradient cut is (-exp(us / vs), (us - vs) / vs * exp(us / vs), 1)
        p = -exp(us / vs)
        q = (us - vs) / vs * -p
        cut = JuMP.@expression(opt.oa_model, p * u + q * v + w)
    else
        return JuMP.AffExpr[]
    end
    return [cut]
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

function MOI.copy_to(opt::Optimizer, src::MOI.ModelLike)
    idx_map = MOI.Utilities.IndexMap()
    get_src_cons(F, S) = MOI.get(src, MOI.ListOfConstraintIndices{F,S}())

    # variable attributes including variable warm start
    has_warm_start = false
    for attr in MOI.get(src, MOI.ListOfVariableAttributesSet())
        if attr == MOI.VariableName()
            continue
        elseif attr == MOI.VariablePrimalStart()
            has_warm_start = true
            continue
        end
        throw(MOI.UnsupportedAttribute(attr))
    end
    function get_start(j::Int)
        return something(
            MOI.get(src, MOI.VariablePrimalStart(), MOI.VariableIndex(j)),
            NaN,
        )
    end

    # variables
    n = MOI.get(src, MOI.NumberOfVariables())
    opt.warm_start = has_warm_start ? fill(NaN, n) : Float64[]
    j = 0
    # integer variables
    cis = get_src_cons(MOI.VariableIndex, MOI.Integer)
    opt.num_int_vars = length(cis)
    for ci in cis
        j += 1
        idx_map[ci] = ci
        idx_map[MOI.VariableIndex(ci.value)] = MOI.VariableIndex(j)
        if has_warm_start
            opt.warm_start[j] = get_start(j)
        end
    end
    # continuous variables
    for vj in MOI.get(src, MOI.ListOfVariableIndices())
        haskey(idx_map, vj) && continue
        j += 1
        idx_map[vj] = MOI.VariableIndex(j)
        if has_warm_start
            opt.warm_start[j] = get_start(j)
        end
    end
    @assert j == n

    # objective
    opt.obj_sense = MOI.MIN_SENSE
    model_c = zeros(n)
    obj_offset = 0.0
    for attr in MOI.get(src, MOI.ListOfModelAttributesSet())
        if attr == MOI.Name()
            continue
        elseif attr == MOI.ObjectiveSense()
            opt.obj_sense = MOI.get(src, MOI.ObjectiveSense())
        elseif attr isa MOI.ObjectiveFunction
            F = MOI.get(src, MOI.ObjectiveFunctionType())
            if !(
                F <: Union{MOI.VariableIndex,MOI.ScalarAffineFunction{Float64}}
            )
                error("objective function type $F not supported")
            end
            obj = convert(
                MOI.ScalarAffineFunction{Float64},
                MOI.get(src, MOI.ObjectiveFunction{F}()),
            )
            for t in obj.terms
                model_c[idx_map[t.variable].value] += t.coefficient
            end
            obj_offset = obj.constant
        else
            throw(MOI.UnsupportedAttribute(attr))
        end
    end
    if opt.obj_sense == MOI.MAX_SENSE
        model_c .*= -1
        obj_offset *= -1
    end
    opt.obj_offset = obj_offset
    opt.c = model_c

    # constraints
    get_con_fun(con_idx) = MOI.get(src, MOI.ConstraintFunction(), con_idx)
    get_con_set(con_idx) = MOI.get(src, MOI.ConstraintSet(), con_idx)

    # SOS1/2 constraints
    opt.SOS12_cons =
        Pair{Vector{Int},<:Union{MOI.SOS1{Float64},MOI.SOS2{Float64}}}[]
    for S in (MOI.SOS1{Float64}, MOI.SOS2{Float64}),
        ci in get_src_cons(MOI.VectorOfVariables, S)

        fi = get_con_fun(ci)
        si = get_con_set(ci)
        idxs = [idx_map[vi].value for vi in fi.variables]
        push!(opt.SOS12_cons, (idxs => si))
        idx_map[ci] = ci
    end

    # equality constraints
    (IA, JA, VA) = (Int[], Int[], Float64[])
    model_b = Float64[]
    for F in (MOI.VectorOfVariables, MOI.VectorAffineFunction{Float64}),
        ci in get_src_cons(F, MOI.Zeros)

        fi = get_con_fun(ci)
        _constraint_IJV(IA, JA, VA, model_b, fi, idx_map)
        idx_map[ci] = ci
    end
    opt.A = SparseArrays.dropzeros!(
        SparseArrays.sparse(IA, JA, VA, length(model_b), n),
    )
    opt.b = model_b

    # conic constraints
    (IG, JG, VG) = (Int[], Int[], Float64[])
    model_h = Float64[]
    cones = MOI.AbstractVectorSet[]
    cone_idxs = Vector{UnitRange{Int}}()

    # build up one nonnegative cone
    for F in (MOI.VectorOfVariables, MOI.VectorAffineFunction{Float64}),
        ci in get_src_cons(F, MOI.Nonnegatives)

        fi = get_con_fun(ci)
        _constraint_IJV(IG, JG, VG, model_h, fi, idx_map)
        idx_map[ci] = ci
    end
    if !isempty(model_h)
        q = length(model_h)
        push!(cones, MOI.Nonnegatives(q))
        push!(cone_idxs, 1:q)
    end

    # other conic constraints
    for (F, S) in MOI.get(src, MOI.ListOfConstraintTypesPresent())
        if !MOI.supports_constraint(opt, F, S)
            throw(MOI.UnsupportedConstraint{F,S}())
        end
        for attr in MOI.get(src, MOI.ListOfConstraintAttributesSet{F,S}())
            if attr == MOI.ConstraintName() ||
               attr == MOI.ConstraintPrimalStart() ||
               attr == MOI.ConstraintDualStart()
                continue
            end
            throw(MOI.UnsupportedAttribute(attr))
        end
        if S in (MOI.Zeros, MOI.Nonnegatives, MOI.Integer) ||
           S <: Union{MOI.SOS1{Float64},MOI.SOS2{Float64}}
            continue # already copied these constraints
        end

        for ci in get_src_cons(F, S)
            fi = get_con_fun(ci)
            idxs = _constraint_IJV(IG, JG, VG, model_h, fi, idx_map)
            push!(cone_idxs, idxs)
            si = get_con_set(ci)
            push!(cones, si)
            idx_map[ci] = ci
        end
    end

    G = SparseArrays.sparse(IG, JG, VG, length(model_h), length(model_c))
    opt.G = SparseArrays.dropzeros!(G)
    opt.h = model_h
    opt.cones = cones
    opt.cone_idxs = cone_idxs
    opt.incumbent = fill(NaN, length(model_c))

    return idx_map
end

function _constraint_IJV(
    IM::Vector{Int},
    JM::Vector{Int},
    VM::Vector,
    vect::Vector,
    func::MOI.VectorOfVariables,
    idx_map::MOI.IndexMap,
)
    dim = MOI.output_dimension(func)
    idxs = length(vect) .+ (1:dim)
    append!(vect, 0.0 for _ in 1:dim)
    append!(IM, idxs)
    append!(JM, idx_map[vi].value for vi in func.variables)
    append!(VM, -1.0 for _ in 1:dim)
    return idxs
end

function _constraint_IJV(
    IM::Vector{Int},
    JM::Vector{Int},
    VM::Vector,
    vect::Vector,
    func::MOI.VectorAffineFunction{Float64},
    idx_map::MOI.IndexMap,
)
    dim = MOI.output_dimension(func)
    start = length(vect)
    append!(vect, func.constants)
    append!(IM, start + vt.output_index for vt in func.terms)
    append!(JM, idx_map[vt.scalar_term.variable].value for vt in func.terms)
    append!(VM, -vt.scalar_term.coefficient for vt in func.terms)
    return start .+ (1:dim)
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

#=
power cone, parametrized by exponent t ∈ (0, 1)
(u, v, w) : u ≥ 0, v ≥ 0, u^t * v^(1-t) ≥ |w|
equivalently (v > 0, u ≥ v * |w / v|^(1/t))
dual cone
(p, q, r) : p ≥ 0, q ≥ 0, (p/t)^t * (q/(1-t))^(1-t) ≥ |r|
equivalently (q > 0, p ≥ t / (1-t) * q * |(1-t) * r / q|^(1/t))
=#

mutable struct PowerCone <: Cache
    t::Real
    oa_s::Vector{JuMP.AffExpr}
    PowerCone() = new()
end

function create_cache(
    oa_s::Vector{JuMP.AffExpr},
    moi_cone::MOI.PowerCone,
    ::Optimizer,
)
    @assert length(oa_s) == 3
    cache = PowerCone()
    cache.t = moi_cone.exponent
    cache.oa_s = oa_s
    return cache
end

function add_init_cuts(cache::PowerCone, opt::Optimizer)
    # add variable bounds
    (u, v, w) = cache.oa_s
    JuMP.@constraint(opt.oa_model, u >= 0)
    JuMP.@constraint(opt.oa_model, v >= 0)
    opt.use_init_fixed_oa || return

    # add cuts (t, 1-t, ±1)
    t = cache.t
    JuMP.@constraints(opt.oa_model, begin
        t * u + (1 - t) * v + w >= 0
        t * u + (1 - t) * v - w >= 0
    end)
    return
end

function get_subp_cuts(z::Vector{Float64}, cache::PowerCone, opt::Optimizer)
    p = z[1]
    q = z[2]
    if min(p, q) < 0
        # z ∉ K
        @warn("dual vector is not in the dual cone")
        return JuMP.AffExpr[]
    end

    # strengthened cut is (p, q, sign(r) * (p/t)^t * (q/(1-t))^(1-t))
    t = cache.t
    r = sign(z[3]) * (p / t)^t * (q / (1 - t))^(1 - t)
    (u, v, w) = cache.oa_s
    cut = JuMP.@expression(opt.oa_model, p * u + q * v + r * w)
    return [cut]
end

function get_sep_cuts(s::Vector{Float64}, cache::PowerCone, opt::Optimizer)
    us = max(s[1], 0)
    vs = max(s[2], 0)
    ws = s[3]

    # check s ∉ K
    t = cache.t
    if us >= 0 && vs >= 0 && (us^t * vs^(1 - t) - abs(ws)) > -opt.tol_feas
        return JuMP.AffExpr[]
    end

    # gradient cut is (t * (us/vs)^(t-1), (1-t) * (us/vs)^t, -sign(ws))
    # perturb point if u or v is near zero
    us = max(us, 1e-8)
    vs = max(vs, 1e-8)
    (u, v, w) = cache.oa_s
    p = t * (us / vs)^(t - 1)
    q = (1 - t) * (us / vs)^t
    cut = JuMP.@expression(opt.oa_model, p * u + q * v - sign(ws) * w)
    return [cut]
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# helpers for cuts

# add initial fixed cuts
function add_init_cuts(opt::Optimizer)
    num_cons = get_num_constraints(opt.oa_model)
    for cache in opt.cone_caches
        Cones.add_init_cuts(cache, opt)
    end
    opt.num_cuts += get_num_constraints(opt.oa_model) - num_cons
    return
end

# add relaxation dual cuts
function add_relax_cuts(opt::Optimizer)
    JuMP.has_duals(opt.relax_model) || return false

    cuts = JuMP.AffExpr[]
    for (ci, cache) in zip(opt.relax_oa_cones, opt.cone_caches)
        append!(cuts, get_dual_cuts(ci, cache, opt, false))
    end
    cuts_added = add_cuts(cuts, opt, false)

    if !cuts_added && opt.verbose
        println("continuous relaxation cuts could not be added")
    end
    return cuts_added
end

# add subproblem dual cuts
function add_subp_cuts(
    opt::Optimizer,
    viol_only::Bool,
    cuts_cache::Union{Nothing,Vector{JuMP.AffExpr}},
)
    JuMP.has_duals(opt.subp_model) || return false

    cuts = JuMP.AffExpr[]
    for (ci, cache) in zip(opt.subp_oa_cones, opt.cone_caches)
        append!(cuts, get_dual_cuts(ci, cache, opt, true))
    end
    cuts_added = add_cuts(cuts, opt, viol_only)

    if !isnothing(cuts_cache)
        append!(cuts_cache, cuts)
    end

    if !cuts_added && opt.verbose
        println("subproblem cuts could not be added")
    end
    return cuts_added
end

# add separation cuts (only if violated)
function add_sep_cuts(opt::Optimizer)
    s_vals = [
        get_value(Cones.get_oa_s(cache), opt.lazy_cb) for
        cache in opt.cone_caches
    ]

    cuts = JuMP.AffExpr[]
    for (s, cache) in zip(s_vals, opt.cone_caches)
        append!(cuts, Cones.get_sep_cuts(s, cache, opt))
    end
    cuts_added = add_cuts(cuts, opt, true)

    if !cuts_added && opt.verbose
        println("separation cuts could not be added")
    end
    return cuts_added
end

# get and rescale relaxation/subproblem dual
function get_dual_cuts(
    ci::JuMP.ConstraintRef,
    cache::Cache,
    opt::Optimizer,
    is_subp::Bool,
)
    z = JuMP.dual(ci)

    z_norm = LinearAlgebra.norm(z, Inf)
    if z_norm < 1e-10
        # discard duals with small norm
        return JuMP.AffExpr[]
    elseif z_norm > 1e11
        println("norm of dual is $z_norm")
    end

    # TODO subproblem-based cut rescaling like old Pajarito
    if is_subp
        status = JuMP.termination_status(opt.subp_model)
        if status in (MOI.INFEASIBLE, MOI.ALMOST_INFEASIBLE)
            # rescale dual rays
            z .*= inv(z_norm)
        end
    end

    return Cones.get_subp_cuts(z, cache, opt)
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

#=
second-order cone
(u, w) : u ≥ ‖w‖

extended formulation
(u, w) : u ≥ 0, ∃ ϕ ≥ 0, u ≥ 2 Σᵢ ϕᵢ, 2 u ϕᵢ ≥ wᵢ²
linear and 3-dim rotated second order cone constraints
=#

mutable struct SecondOrderCone{E<:NatExt} <: Cache
    oa_s::Vector{JuMP.AffExpr}
    d::Int
    ϕ::Vector{JuMP.VariableRef}
    SecondOrderCone{E}() where {E<:NatExt} = new{E}()
end

function create_cache(
    oa_s::Vector{JuMP.AffExpr},
    moi_cone::MOI.SecondOrderCone,
    opt::Optimizer,
)
    dim = MOI.dimension(moi_cone)
    @assert dim == length(oa_s)
    d = dim - 1
    E = nat_or_ext(opt, d)
    cache = SecondOrderCone{E}()
    cache.oa_s = oa_s
    cache.d = d
    return cache
end

function get_subp_cuts(
    z::Vector{Float64},
    cache::SecondOrderCone,
    opt::Optimizer,
)
    return _get_cuts(z[2:end], cache, opt)
end

function get_sep_cuts(
    s::Vector{Float64},
    cache::SecondOrderCone,
    opt::Optimizer,
)
    us = s[1]
    @views ws = s[2:end]
    ws_norm = LinearAlgebra.norm(ws)
    # check s ∉ K
    if us - ws_norm > -opt.tol_feas
        return JuMP.AffExpr[]
    end

    # cut is (1, -ws / ‖ws‖)
    r = ws / -ws_norm
    return _get_cuts(r, cache, opt)
end

# unextended formulation

function add_init_cuts(cache::SecondOrderCone{Nat}, opt::Optimizer)
    # add variable bound
    u = cache.oa_s[1]
    JuMP.@constraint(opt.oa_model, u >= 0)
    opt.use_init_fixed_oa || return

    # add cuts u ≥ |wᵢ|
    @views w = cache.oa_s[2:end]
    d = cache.d
    JuMP.@constraints(opt.oa_model, begin
        [i in 1:d], u >= w[i]
        [i in 1:d], u >= -w[i]
    end)
    return
end

function _get_cuts(
    r::Vector{Float64},
    cache::SecondOrderCone{Nat},
    opt::Optimizer,
)
    # strengthened cut is (‖r‖, r)
    clean_array!(r) && return JuMP.AffExpr[]
    p = LinearAlgebra.norm(r)
    u = cache.oa_s[1]
    @views w = cache.oa_s[2:end]
    cut = JuMP.@expression(opt.oa_model, p * u + LinearAlgebra.dot(r, w))
    return [cut]
end

# extended formulation

num_ext_variables(cache::SecondOrderCone{Ext}) = cache.d

function extend_start(
    cache::SecondOrderCone{Ext},
    s_start::Vector{Float64},
    opt::Optimizer,
)
    u_start = s_start[1]
    w_start = s_start[2:end]
    if u_start < opt.tol_feas
        return zeros(cache.d)
    end
    return [w_i / 2u_start * w_i for w_i in w_start]
end

function setup_auxiliary(cache::SecondOrderCone{Ext}, opt::Optimizer)
    @assert cache.d >= 2
    ϕ = cache.ϕ = JuMP.@variable(opt.oa_model, [1:(cache.d)], lower_bound = 0)
    u = cache.oa_s[1]
    JuMP.@constraint(opt.oa_model, u >= 2 * sum(ϕ))
    return ϕ
end

function add_init_cuts(cache::SecondOrderCone{Ext}, opt::Optimizer)
    # add variable bound
    u = cache.oa_s[1]
    JuMP.@constraint(opt.oa_model, u >= 0)
    opt.use_init_fixed_oa || return

    # add disaggregated cuts (1, 2, ±2) on (u, ϕᵢ, wᵢ), implying u ≥ |wᵢ|
    @views w = cache.oa_s[2:end]
    d = cache.d
    ϕ = cache.ϕ
    JuMP.@constraints(
        opt.oa_model,
        begin
            [i in 1:d], u + 2 * ϕ[i] + 2 * w[i] >= 0
            [i in 1:d], u + 2 * ϕ[i] - 2 * w[i] >= 0
        end
    )
    return
end

function _get_cuts(
    r::Vector{Float64},
    cache::SecondOrderCone{Ext},
    opt::Optimizer,
)
    clean_array!(r) && return JuMP.AffExpr[]
    p = LinearAlgebra.norm(r)
    u = cache.oa_s[1]
    @views w = cache.oa_s[2:end]
    ϕ = cache.ϕ
    cuts = JuMP.AffExpr[]
    for i in 1:(cache.d)
        r_i = r[i]
        iszero(r_i) && continue
        # strengthened disaggregated cut on (u, ϕᵢ, wᵢ) is (rᵢ² / 2‖r‖, ‖r‖, rᵢ)
        cut = JuMP.@expression(
            opt.oa_model,
            r_i^2 / 2p * u + p * ϕ[i] + r_i * w[i]
        )
        push!(cuts, cut)
    end
    return cuts
end

# Copyright (c) 2021-2022 Chris Coey and contributors
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# a solver for mixed-integer conic problems using outer approximation and conic duality

module Pajarito

import JuMP
import LinearAlgebra
import MathOptInterface as MOI
import Printf
import SparseArrays

abstract type Cache end

include("optimizer.jl")
include("Cones/Cones.jl")
include("algorithms.jl")
include("models.jl")
include("cuts.jl")
include("JuMP_tools.jl")
include("MOI_wrapper.jl")
include("MOI_copy_to.jl")

end
